# source: http://www.usb.org/developers/docs/devclass_docs/USB_Video_Class_1_5.zip, 2017-01-08


class SUBCLASS:
    SC_UNDEFINED = 0x00
    SC_VIDEOCONTROL = 0x01
    SC_VIDEOSTREAMING = 0x02
    SC_VIDEO_INTERFACE_COLLECTION = 0x03


class PROTOCOL:
    SC_PROTOCOL_UNDEFINED = 0x00
    SC_PROTOCOL_15 = 0x01


class DESCRIPTOR_SUBTYPE:
    VC_DESCRIPTOR_UNDEFINED = 0x00
    VC_HEADER = 0x01
    VC_INPUT_TERMINAL = 0x02
    VC_OUTPUT_TERMINAL = 0x03
    VC_SELECTOR_UNIT = 0x04
    VC_PROCESSING_UNIT = 0x05
    VC_EXTENSION_UNIT = 0x06
    VC_ENCODING_UNIT = 0x07

    VS_UNDEFINED = 0x00
    VS_INPUT_HEADER = 0x01
    VS_OUTPUT_HEADER = 0x02
    VS_STILL_IMAGE_FRAME = 0x03
    VS_FORMAT_UNCOMPRESSED = 0x04
    VS_FRAME_UNCOMPRESSED = 0x05
    VS_FORMAT_MJPEG = 0x06
    VS_FRAME_MJPEG = 0x07
    VS_FORMAT_MPEG2TS = 0x0A
    VS_FORMAT_DV = 0x0C
    VS_COLORFORMAT = 0x0D
    VS_FORMAT_FRAME_BASED = 0x10
    VS_FRAME_FRAME_BASED = 0x11
    VS_FORMAT_STREAM_BASED = 0x12
    VS_FORMAT_H264 = 0x13
    VS_FRAME_H264 = 0x14
    VS_FORMAT_H264_SIMULCAST = 0x15
    VS_FORMAT_VP8 = 0x16
    VS_FRAME_VP8 = 0x17
    VS_FORMAT_VP8_SIMULCAST = 0x18

    EP_UNDEFINED = 0x00
    EP_GENERAL = 0x01
    EP_ENDPOINT = 0x02
    EP_INTERRUPT = 0x03


class TERMINAL_TYPE:
    TT_VENDOR_SPECIFIC = 0x0100
    TT_STREAMING = 0x0101

    ITT_VENDOR_SPECIFIC = 0x0200
    ITT_CAMERA = 0x0201
    ITT_MEDIA_TRANSPORT_INPUT = 0x0202

    OTT_VENDOR_SPECIFIC = 0x0300
    OTT_DISPLAY = 0x0301
    OTT_MEDIA_TRANSPORT_OUTPUT = 0x0302

    EXTERNAL_VENDOR_SPECIFIC = 0x0400
    COMPOSITE_CONNECTOR = 0x0401
    SVIDEO_CONNECTOR = 0x0402
    COMPONENT_CONNECTOR = 0x0403


class FORMAT_GUID:
    YUY2 = "32595559-0000-0010-8000-00AA00389B71"
    NV12 = "3231564E-0000-0010-8000-00AA00389B71"
    M420 = "3032344D-0000-0010-8000-00AA00389B71"
    I420 = "30323449-0000-0010-8000-00AA00389B71"
